<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-col :span="18">
        <el-input
          clearable
          @keyup.enter.native="handleFind"
          class="filter-item"
          style="width: 200px;"
          v-model="name"
          placeholder="请输入项目名称"
        ></el-input>
        <!--<el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind" v-permission="'/girlProject/getList'">查询</el-button>-->
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查询</el-button>
      </el-col>
      <el-col :span="6">
        <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit">新增项目</el-button>
        <!--<el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit" v-permission="'/girlProject/add'">新增项目</el-button>-->
      </el-col>
    </div>

    <el-table :data="tableData"
              style="width: 100%"
              @selection-change="handleSelectionChange"
              :default-sort="{prop: 'sort', order: 'descending'}">
      <el-table-column label="ID" width="50" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="项目名称" width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="来源" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.source }}</span>
        </template>
      </el-table-column>
      <el-table-column label="KEY" width="150" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.proKey }}</span>
        </template>
      </el-table-column>·
      <el-table-column label="项目开关" width="100" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.onOff == 1">开</span>
          <span v-else>关</span>
        </template>
      </el-table-column>
      <el-table-column label="判断会员" width="100" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isVip == 1">开</span>
          <span v-else>关</span>
        </template>
      </el-table-column>
      <el-table-column label="认证信息" width="400" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.authentication }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createTime" sortable="custom" :sort-by="['createTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" width="180" align="center" prop="updateTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" fixed="right" min-width="95">
        <template slot-scope="scope">
          <el-button @click="handleEdit(scope.row)" type="primary" size="small">编辑</el-button>
          <el-button @click="userCostOpen(scope.row)" type="primary" size="small">用户费用配置</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 项目 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="30%" :before-close="handleClose">
      <el-form :model="form" :rules="rules" ref="form">
        <el-form-item label="uid" :label-width="formLabelWidth" v-if="false">
          <el-input v-model="form.uid" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="项目名称" :label-width="formLabelWidth" prop="name">
          <el-input v-model="form.name" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="来源" :label-width="formLabelWidth" prop="source">
          <el-input v-model="form.source" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="KEY" :label-width="formLabelWidth" prop="proKey">
          <el-input v-model="form.proKey" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="项目开关" :label-width="formLabelWidth" prop="onOff">
          <input type="radio" v-model="form.onOff" value="1" />&nbsp; 开 &nbsp;
          <input type="radio" v-model="form.onOff" value="0" />&nbsp; 关 &nbsp;
        </el-form-item>
        <el-form-item label="判断会员" :label-width="formLabelWidth" prop="isVip">
          <input type="radio" v-model="form.isVip" value="1" />&nbsp; 开 &nbsp;
          <input type="radio" v-model="form.isVip" value="0" />&nbsp; 关 &nbsp;
        </el-form-item>
        <el-form-item label="认证信息" :label-width="formLabelWidth" prop="authentication">
          <el-input v-model="form.authentication" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>

    <!-- 用户费用列表 -->
    <el-dialog :title="userCostTitle" class="header-title" :visible.sync="userCostFormVisible"  width="65%" :before-close="userCostHandleClose">
      <el-form :model="userCostQueryParams" :span="50" ref="userCostQueryParams">

        <el-col :span="22">
          <el-form-item label="项目名称">
            <span>{{userCostQueryParams.projectName}}</span>
          </el-form-item>
        </el-col>
        <el-col :span="2">
          <el-button class="filter-item" type="primary" @click="userCostHandleAdd" icon="el-icon-edit">新增</el-button>
        </el-col>

        <el-table :data="userCostTableData" style="width:100%" class="show_table" :default-sort="{prop: 'sort', order: 'descending'}">
          <el-table-column label="ID" width="100" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.uid }}</span>
            </template>
          </el-table-column>
          <el-table-column label="会员等级ID" width="280" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.levelId }}</span>
            </template>
          </el-table-column>
          <el-table-column label="会员等级名称" width="200" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.levelName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="平台费用" width="100" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.cost }}</span>
            </template>
          </el-table-column>
          <el-table-column label="创建时间" width="180" align="center">
            <template slot-scope="scope">
              <span >{{ scope.row.createTime }}</span>
            </template>
          </el-table-column>
          <el-table-column label="更新时间" width="180" align="center">
            <template slot-scope="scope">
              <span >{{ scope.row.updateTime }}</span>
            </template>
          </el-table-column>

          <el-table-column label="操作" fixed="right" min-width="140">
            <template slot-scope="scope">
              <el-button @click="userCostHandleEdit(scope.row)" type="primary" size="small">编辑</el-button>
              <el-button @click="userCostHandleDelete(scope.row)" v-if="scope.row.levelName != '普通会员'" type="primary" size="small">删除</el-button>
            </template>
          </el-table-column>
        </el-table>

        <!--图集分页-->
        <div class="block">
          <el-pagination
            @size-change="userCostHandleSizeChange"
            @current-change="userCostHandleCurrentChange"
            :current-page.sync="userCostCurrentPage"
            :page-sizes="[40, 80, 120, 200]"
            :page-size="userCostPageSize"
            layout="total, prev, pager, next, jumper, sizes"
            :total="userCostTotal">
          </el-pagination>
        </div>
      </el-form>
      <div slot="footer" class="dialog-footer">
      </div>
    </el-dialog>

    <!-- 用户费用 添加或修改对话框 -->
    <el-dialog :title="userCostTitleAddOrEdit" :visible.sync="userCostDialogFormVisible" width="30%" :before-close="userCostAddOrEditHandleClose">
      <el-form :model="userCostForm" :rules="userCostRules" ref="userCostForm">
        <el-form-item label="项目名称" :label-width="formLabelWidth" prop="name">
          <span>{{userCostQueryParams.projectName}}</span>
        </el-form-item>
        <el-form-item label="uid" :label-width="formLabelWidth" v-if="false">
          <el-input v-model="userCostForm.uid" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="会员等级ID" :label-width="formLabelWidth" prop="levelId" v-if="userCostForm.levelName != '普通会员'">
          <el-input v-model="userCostForm.levelId" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="会员等级名称" :label-width="formLabelWidth" prop="levelName" v-if="userCostForm.levelName != '普通会员'">
          <el-input v-model="userCostForm.levelName" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
        <el-form-item label="平台费用" :label-width="formLabelWidth" prop="cost">
          <el-input v-model="userCostForm.cost" auto-complete="off" style="width: 80%"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="userCostAddOrEditHandleClose">取 消</el-button>
        <el-button type="primary" @click="userCostSubmitForm">确 定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {
  getProjectList,
  addProject,
  editProject,
} from "@/api/girlProject";
import {
  getUserCostList,
  addUserCost,
  editUserCost,
  deleteUserCost,
} from "@/api/girlUserCost";
export default {
  data() {
    return {
      userCostTableData: [],//用户费用数据
      userCostFormVisible: false,
      userCostQueryParams:{
        projectUid:null,
        projectName:null
      },
      userCostTitle: "用户费用列表",
      userCostCurrentPage: 1,
      userCostTotal: null,
      userCostPageSize: 40,
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      name: "",
      currentPage: 1,
      pageSize: 10,
      total: 0, //总数量
      title: "增加项目",
      userCostTitleAddOrEdit: "增加",
      dialogFormVisible: false, //控制弹出框
      userCostDialogFormVisible: false, //控制弹出框
      formLabelWidth: "120px",
      isEditForm: false,
      userCostIsEditForm: false,
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      form: {},
      userCostForm: {},
      rules: {
        name: [
          {required: true, message: '项目名称不能为空', trigger: 'blur'},
          {min: 1, max: 32, message: '最多输入32个字'},
        ],
        proKey: [
          {min: 0, max: 32, message: '最多输入32个字'},
        ],
        source: [
          {required: true, message: '来源不能为空', trigger: 'blur'},
          {pattern: /^[0-9]\d*$/, message: '来源只能为自然数'},
        ],
        authentication: [
          {min: 1, max: 100, message: '最多输入100个字'},
        ],
      },
      userCostRules: {
        levelId: [
          {required: true, message: '会员等级ID不能为空', trigger: 'blur'},
          {min: 1, max: 32, message: '最多输入32个字'},
        ],
        levelName: [
          {min: 1, max: 32, message: '最多输入32个字'},
        ],
        cost: [
          {pattern: /^[0-9]\d*$/, message: '平台费用只能为自然数'},
        ]
      },
    };
  },
  created() {
    this.projectList();
  },
  methods: {

    projectList: function() {
      var params = {};
      params.name = this.name;
      params.currentPage = this.currentPage
      params.pageSize = this.pageSize
      getProjectList(params).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        content: null,
        clickCount: 0,
        sort: 0
      };
      return formObject;
    },
    handleFind: function() {
      this.currentPage = 1
      this.projectList();
    },
    handleAdd: function() {
      this.title = "增加项目"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
    },
    handleEdit: function(row) {
      this.title = "编辑项目";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = row;
    },
    handleDelete: function(row) {
      var that = this;
      this.$confirm("此操作将把项目删除, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {

          var params = [];
          params.push(row);
          deleteBatchProject(params).then(response => {
            if(response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            that.projectList();
          });
        })
        .catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.projectList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.projectList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          if (this.isEditForm) {
            editProject(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.projectList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          } else {
            addProject(this.form).then(response => {
              console.log(response);
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.projectList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        }
      })
    },

    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    handleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
      this.projectList();
    },

    userCostHandleClose(){
      this.userCostFormVisible = false;
      this.userCostQueryParams.projectUid = null;
      this.userCostTableData = [];
    },

    userCostAddOrEditHandleClose(){
      this.userCostDialogFormVisible = false;
      this.userCostList();
    },

    /**
     * 翻页事件
     */
    userCostHandleSizeChange(val) {
      this.userCostPageSize = val;
      this.userCostList();
    },
    userCostHandleCurrentChange(val) {
      this.userCostCurrentPage = val;
      this.userCostList();
    },
    userCostList() {
      var params = {};
      params.projectUid = this.userCostQueryParams.projectUid;
      params.pageSize = this.userCostPageSize;
      params.currentPage = this.userCostCurrentPage;
      getUserCostList(params).then(response =>{
          this.userCostTableData = response.data.records
          this.userCostCurrentPage = response.data.current;
          this.userCostPageSize = response.data.size;
          this.userCostTotal = response.data.total;
        });
    },
    //用户费用列表
    userCostOpen(row) {
        this.userCostFormVisible = true;
        this.userCostQueryParams.projectUid = row.uid;
        this.userCostQueryParams.projectName = row.name;
        this.userCostList();
    },
    userCostHandleAdd: function() {
      this.userCostTitleAddOrEdit = "增加"
      this.userCostDialogFormVisible = true;
      this.userCostForm = this.getFormObject();
      this.userCostIsEditForm = false;
    },
    userCostHandleEdit: function(row) {
      this.userCostTitleAddOrEdit = "编辑";
      this.userCostDialogFormVisible = true;
      this.userCostIsEditForm = true;
      this.userCostForm = row;
    },
    userCostHandleDelete: function(row) {
      var that = this;
      this.$confirm("此操作将把用户费用删除, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
          deleteUserCost(row).then(response => {
            if(response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            this.userCostList();
          });
        }).catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    userCostSubmitForm: function() {
      this.$refs.userCostForm.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          this.userCostForm.projectUid = this.userCostQueryParams.projectUid;
          if (this.userCostIsEditForm) {
            editUserCost(this.userCostForm).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.userCostDialogFormVisible = false;
                this.userCostList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          } else {
            addUserCost(this.userCostForm).then(response => {
              console.log(response);
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.userCostDialogFormVisible = false;
                this.userCostList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        }
      })
    },
  }
};
</script>
